package ChildrenSavingsAccount;

import com.metamaxim.modelscope.callbacks.*;
import java.util.*;

public class DashboardEffectivenessInvitations extends Behaviour {


// Define the start- end end date of the reporting period (reporting year)

public Date getStartRY(){
			Calendar cal=Calendar.getInstance();
			Date StartRY = this.getDate("Start of Reporting Year"); 
			cal.setTime(StartRY);
			return StartRY;
	}	

public Date getEndOfReportingYear(){	
			Calendar cal=Calendar.getInstance();
			Date StartRY = getStartRY();
			cal.setTime(StartRY);
			// If the start date is 1 August, then the end date is 1 August next year:
			cal.add(Calendar.YEAR, +1);
			Date EndRY=cal.getTime();
			cal.setTime(EndRY);
			// If the start date is 1 August, then the end date is 31 July next year:
			cal.add(Calendar.DATE, -1);
			Date EndOfReportingYear=cal.getTime();
			return EndOfReportingYear;
	}		
	

// Number of Invitations Sent

public int  getNumberOfInvitationsSent(){
		int NumberOfInvitationsSent=0;

			String DashboardName=this.getString("Dashboard Name");

		Instance[] invitation =   selectInState("Invitation ChildrenSavingsAccount", "@any"); 
		for (int i = 0; i < invitation.length; i++) {
		String InvitationName=invitation[i].getString("Invitation Name");

		if (InvitationName.equals(DashboardName))
		NumberOfInvitationsSent=invitation[i].getInteger("Number of Invitations Sent");
		}
		return NumberOfInvitationsSent;
	}

	
// Number of Applications from the Invitation

public int  getNumberOfApplicationsFromTheInvitation(){
		int NumberOfApplicationsFromTheInvitation=0;

			Date StartRY = getStartRY();
			Date EndOfReportingYear = getEndOfReportingYear();
			Instance DashInv=this.getInstance("Invitation ChildrenSavingsAccount");

		Instance[] application =   selectInState("Application ChildrenSavingsAccount", "@any");
		for (int i = 0; i < application.length; i++) {
		Date ApplDate=application[i].getDate("Application Date");
		Instance ApplInv=application[i].getInstance("Invitation ChildrenSavingsAccount");

		if (ApplDate.compareTo(StartRY)>=0 && ApplDate.compareTo(EndOfReportingYear)<=0 && DashInv.equals(ApplInv))
		NumberOfApplicationsFromTheInvitation+=1;
		}
		return NumberOfApplicationsFromTheInvitation;
	}	


// Number of Minor Customers from the Invitation

public int  getNumberOfMinorCustomersFromTheInvitation(){
		int NumberOfMinorCustomersFromTheInvitation=0;
			
			Date StartRY = getStartRY();
			Date EndOfReportingYear = getEndOfReportingYear();;
			String DashboardName=this.getString("Dashboard Name");
			
		Instance[] MinCust =   selectInState("Minor Customer", "@any"); 
		for (int i = 0; i < MinCust.length; i++) {
		Date regDate=MinCust[i].getDate("Registration Date");
		String MinCustInv=MinCust[i].getString("Invitation");

		if (regDate.compareTo(StartRY)>=0 && regDate.compareTo(EndOfReportingYear)<=0 && DashboardName.equals(MinCustInv))
		NumberOfMinorCustomersFromTheInvitation+=1;}
		return NumberOfMinorCustomersFromTheInvitation;
	}

		
// Converstion Rate Invitations to Applications

public int  getConversionRateInvitationsToApplications() { 
	
			int ApplFromInv = getNumberOfApplicationsFromTheInvitation();
			int Invitations = getNumberOfInvitationsSent();;

		int ConversionRateInvitationsToApplications=0;

		if 	(Invitations==0) {
		ConversionRateInvitationsToApplications=0;
		}
		else {
		ConversionRateInvitationsToApplications = (100*ApplFromInv)/Invitations;
		}
		return 	ConversionRateInvitationsToApplications;			
	}


// Converstion Rate Applications to New Minor Customers

public int  getConversionRateApplicationsToMinorCustomers() { 

			int MinCustFromInv = getNumberOfMinorCustomersFromTheInvitation();
			int ApplFromInv = getNumberOfApplicationsFromTheInvitation();;

		int ConversionRateApplicationsToMinorCustomers=0;

		if 	(ApplFromInv==0) {
		ConversionRateApplicationsToMinorCustomers=0;
		}
		else {
		ConversionRateApplicationsToMinorCustomers = (100*MinCustFromInv)/ApplFromInv;
		}
		return 	ConversionRateApplicationsToMinorCustomers;	
	}


// Converstion Rate Invitations to New Minor Customers

public int  getConversionRateInvitationsToMinorCustomers() { 

			int MinCustFromInv = getNumberOfMinorCustomersFromTheInvitation();
			int Invitations = getNumberOfInvitationsSent();;

		int ConversionRateInvitationsToMinorCustomers=0;

		if 	(Invitations==0) {
		ConversionRateInvitationsToMinorCustomers=0;
		}
		else {
		ConversionRateInvitationsToMinorCustomers = (100*MinCustFromInv)/Invitations;
		}
		return	ConversionRateInvitationsToMinorCustomers;
		}
}
